<?php
class Loader {
    /** 
     * 命名空间-路径映射表 
     */
    public static $vendorMap = array(
        'app' => __DIR__ . DIRECTORY_SEPARATOR . 'app',
    );

    /**
     * 自动加载器
     * @param string $class 自动传入的命名空间路径
     */
    public static function autoload($class) {
        # 获得解析后的命名空间绝对路径
        $file = self::findFile($class);
        if (file_exists($file)) {
            # 调用引入
            self::includeFile($file);
        }
    }

    /**
     * 解析命名空间对应的文件路径
     * @param string $class 命名空间路径
     */
    private static function findFile($class) {
        $vendor    = substr($class, 0, strpos($class, '\\'));   // 顶级命名空间
        $vendorDir = self::$vendorMap[$vendor];                 // 文件基目录
        $filePath  = substr($class, strlen($vendor)) . '.php';  // 文件相对路径
        return strtr($vendorDir . $filePath, '\\', DIRECTORY_SEPARATOR); // 文件标准路径
    }

    /**
     * 引入文件
     */
    private static function includeFile($file) {
        if (is_file($file)) {
            include $file;
        }
    }
}